let () = Printf.printf "test pre 1\n"; flush stdout

open GMain

let () = Printf.printf "test pre 2\n"; flush stdout

let main s =
  let window = GWindow.window ~border_width: 10 () in
  Printf.printf "test 1\n"; flush stdout;
  let handle = Rsvg.handle_new () in
  Printf.printf "test 2\n"; flush stdout;
  let fd = open_in s in
  Printf.printf "test 3\n"; flush stdout;
  let size = in_channel_length fd in
  Printf.printf "test 4\n"; flush stdout;
  Printf.printf "size = %d\n" size; flush stdout;
  let buf = String.make size ' ' in
  Printf.printf "test 5\n"; flush stdout;
  let read = input fd buf 0 size in
  Printf.printf "test 6\n"; flush stdout;
  Printf.printf "read = %d\n" read; flush stdout;
  let f w h = 
    Printf.printf "Size callback, w=%d, h=%d\n" w h; flush stdout;
    131, 32
  in
  let _ = Rsvg.handle_set_size_callback handle f in
  Printf.printf "test 7\n"; flush stdout;
  let b = Rsvg.handle_write handle buf size in
  Printf.printf "test 8\n"; flush stdout;
  Printf.printf "result 1 = %s\n" (if b then "ok" else "nok"); flush stdout;
  let b = Rsvg.handle_close handle in
  Printf.printf "test 9\n"; flush stdout;
  Printf.printf "result 1 = %s\n" (if b then "ok" else "nok"); flush stdout;
  let pixbuf = Rsvg.handle_get_pixbuf handle in
  Printf.printf "test 10\n"; flush stdout;
  let () = Rsvg.handle_free handle in 
  Printf.printf "test 11\n"; flush stdout;
  let () = close_in fd in
  Printf.printf "test 12\n"; flush stdout;
  let image = GMisc.image ~width:131 ~height:32 ~packing:window#add () in 
  Printf.printf "test 13\n"; flush stdout;
  image#set_pixbuf pixbuf;
  Printf.printf "test 14\n"; flush stdout;
  (*
  window#event#connect#delete
    ~callback:(fun _ -> prerr_endline "Delete event occured"; true);
  *)
  ignore (window#connect#destroy ~callback:Main.quit);
  Printf.printf "test 15\n"; flush stdout;
  (*
  image#connect#clicked ~callback:(fun () -> prerr_endline "Hello World");
  image#connect#clicked ~callback:window#destroy;
  *)
  window#show ();
  Printf.printf "test 16\n"; flush stdout;
  Main.main ()

let _ = Printexc.print main "tetris1.svg"

